#include "mylib/commen_include.h"
/*
// OpenCV 库
#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>

// PCL 库
#include <pcl/io/pcd_io.h>
#include <pcl/point_types.h>

// 定义点云类型
typedef pcl::PointXYZRGBA PointT;
typedef pcl::PointCloud<PointT> PointCloud;
 */
/*
    封装的含义：
    1.对属性和方法进行封装
    2.对属性和方法进行访问
    类封装了成员变量和成员函数，使用指针的方法可以用->进行调用
*/
struct Plane
{
    int num_points_;
    Eigen::Vector3d normal_;
    double dis_;
};
int main(int argc, char** argv)
{
    std::cout<<"Hello SLAM!"<<std::endl;
    std::mt19937 gen(std::chrono::system_clock::now().time_since_epoch().count());

    std::uniform_real_distribution<double> d_x{0.0, 4.0};
    std::uniform_real_distribution<double> d_y{0.0, 5.0};
    Plane plane;
    Eigen::Vector3d pt1(-1,6,2);
    Eigen::Vector3d pt2(-1,2,2);
    Eigen::Vector3d pt3(-1,2,6);
    Eigen::Vector3d pt4(-1,6,6);
    /*
    Eigen::Vector3d pt1(1,1,1);
    Eigen::Vector3d pt2(5,1,1);
    Eigen::Vector3d pt3(5,5,1);
    Eigen::Vector3d pt4(1,5,1);*/
    Eigen::Vector4d plane_homo;
    plane_homo.head(3) =  (pt1-pt3).cross((pt2-pt3));
    plane_homo(3) = -pt3.transpose()*(pt1.cross(pt2));
    plane.normal_ =plane_homo.head(3).normalized();
    plane.dis_ = -plane_homo(3)/plane_homo.head(3).norm();
    std::cout<<"plane normal is "<<plane.normal_.transpose()<<std::endl;
    std::cout<<"plane distance is "<<plane.dis_<<std::endl;
    plane.num_points_ =100;
    //plane.normal_<<0,0,1;
    //plane.dis_ = 1;
    std::vector<Eigen::Vector3d> plane_points_;
    for (int i = 0; i < plane.num_points_; ++i) {
        Eigen::Vector3d pt;
        pt[1] = d_x(gen);
        pt[2] = d_y(gen);
        pt[0] = (plane.dis_ - plane.normal_[1] * pt[1] - plane.normal_[2] * pt[2]) / plane.normal_[0];
        plane_points_.push_back(pt);

    }
    std::cout<<plane_points_[2].transpose()<<std::endl;

    std::ofstream createPointinPlaneFile("../res/PointinPlane_yz.txt");
    for(int po = 0; po < int(plane_points_.size()); ++po){

        createPointinPlaneFile << (po + 1);
        createPointinPlaneFile << " " << plane_points_[po](0) << " " << plane_points_[po](1) << " " << plane_points_[po](2);
        //createPointinPlaneFile << " " << plane_points_[po].transpose();
        createPointinPlaneFile << std::endl;
    }
/*    // 遍历深度图
    for (int m = 0; m < depth.rows; m++)
        for (int n=0; n < depth.cols; n++)
        {
            // 获取深度图中(m,n)处的值
            ushort d = depth.ptr<ushort>(m)[n];
            // d 可能没有值，若如此，跳过此点
            if (d == 0)
                continue;
            // d 存在值，则向点云增加一个点
            PointT p;

            // 计算这个点的空间坐标
            p.z = double(d) / camera_factor;
            p.x = (n - camera_cx) * p.z / camera_fx;
            p.y = (m - camera_cy) * p.z / camera_fy;

            // 从rgb图像中获取它的颜色
            // rgb是三通道的BGR格式图，所以按下面的顺序获取颜色
            p.b = rgb.ptr<uchar>(m)[n*3];
            p.g = rgb.ptr<uchar>(m)[n*3+1];
            p.r = rgb.ptr<uchar>(m)[n*3+2];

            // 把p加入到点云中
            cloud->points.push_back( p );
        }
    // 设置并保存点云
    cloud->height = 1;
    cloud->width = cloud->points.size();
    cout<<"point cloud size = "<<cloud->points.size()<<endl;
    for(size_t i=0;i<cloud->points.size();++i)
    std::cout<<"    "<<cloud->points[i].x
    <<" "<<cloud->points[i].y
    <<" "<<cloud->points[i].z<<std::endl;
    cloud->is_dense = false;
    pcl::io::savePCDFile( "./pointcloud.pcd", *cloud );
    // 清除数据并退出
    cloud->points.clear();
    cout<<"Point cloud saved."<<endl;*/
    return 0;
}

